package org.bitbucket.bradleysmithllc.etlunit;

public class TestAssertionFailure extends Exception
{
	private final String failureId;

	public TestAssertionFailure(String msg)
	{
		this(msg, TestConstants.FAIL_UNSPECIFIED);
	}

	public TestAssertionFailure(String msg, String failureId)
	{
		super(msg);

		this.failureId = failureId;
	}

	public TestAssertionFailure(String msg, Exception cause)
	{
		this(msg, TestConstants.FAIL_UNSPECIFIED, cause);
	}

	public TestAssertionFailure(String msg, String failureId, Exception cause)
	{
		super(msg, cause);

		this.failureId = failureId;
	}

	public String getFailureId()
	{
		return failureId;
	}
}