package org.bitbucket.bradleysmithllc.etlunit.feature;

import org.bitbucket.bradleysmithllc.etlunit.LogListener;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestClass;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestMethod;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestOperation;

import java.util.List;

public class FeatureLogListenerProxy implements LogListener
{
	private final FeatureProxyBase<LogListener> base;

	public FeatureLogListenerProxy(List<Feature> featureList)
	{
		base = new FeatureProxyBase<LogListener>(featureList, new FeatureProxyBase.Getter<LogListener>()
		{
			@Override
			public LogListener get(Feature f)
			{
				return f.getLogListener();
			}
		});
	}

	@Override
	public void log(message_type type, String text, ETLTestClass etlClass, ETLTestMethod method, ETLTestOperation operation)
	{
		for (LogListener listener : base.getList())
		{
			listener.log(type, text, etlClass, method, operation);
		}
	}

	@Override
	public void log(message_type type, Throwable error, String text, ETLTestClass etlClass, ETLTestMethod method, ETLTestOperation operation)
	{
		for (LogListener listener : base.getList())
		{
			listener.log(type, error, text, etlClass, method, operation);
		}
	}
}