package org.bitbucket.bradleysmithllc.etlunit.feature.workspace;

import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;

public class Workspace
{
	private final File root;

	public Workspace(File root) throws IOException {
		this.root = root;

		mkdir();
	}

	private void mkdir() throws IOException {
		FileUtils.forceMkdir(root);
	}

	public String getRootPath()
	{
		return root.getAbsolutePath();
	}

	public File getRoot()
	{
		return root;
	}

	public void purge() throws IOException {
		FileUtils.deleteDirectory(root);
		mkdir();
	}
}